

################################################################################


class DetailsOerstedField:
  
  
#------------------------------------------------------------------------------#

  
  exists = False
  
  a1 = None
  c1 = None
  solverComp1 = None

  a2 = None
  c2 = None
  f2 = None
  
  
#------------------------------------------------------------------------------#


  def __init__(self, mesh, NeumannSpace, DirichletSpace, h2, solvetol):
    
    if not(type(self).exists):
      type(self)._femOerstedStaticInitialize(mesh, NeumannSpace, DirichletSpace \
        , h2, solvetol)
      type(self).exists = True
  
  
#------------------------------------------------------------------------------#


  @classmethod
  def _femOerstedStaticInitialize(cls, mesh, NeumannSpace, DirichletSpace, h2 \
    , solvetol):
    from ngsolve import LinearForm, CGSolver, TaskManager, Preconditioner \
      , Laplace, BilinearForm, SymbolicBFI
    from commix._tools.algebra import FrobeniusInnerProd

    cls.a1 = BilinearForm(NeumannSpace, symmetric=False)
    uX, vX = NeumannSpace.TrialFunction(), NeumannSpace.TestFunction()
    vectorLaplaceX = FrobeniusInnerProd(uX.Deriv(), vX.Deriv())
    cls.a1 += SymbolicBFI(vectorLaplaceX.Compile(wait=True, realcompile=True))
    
    cls.c1 = Preconditioner(cls.a1, "local")
    with TaskManager():
      cls.a1.Assemble()
      cls.solverComp1 = CGSolver(mat=cls.a1.mat, pre=cls.c1.mat \
        , precision=solvetol, maxsteps=4000)
    
    cls.a2 = BilinearForm(DirichletSpace, symmetric=False)
    uY, vY = DirichletSpace.TrialFunction(), DirichletSpace.TestFunction()
    vectorLaplaceY = FrobeniusInnerProd(uY.Deriv(), vY.Deriv())
    cls.a2 += SymbolicBFI(vectorLaplaceY.Compile(wait=True, realcompile=True))

    cls.c2 = Preconditioner(cls.a2, "bddc")

    with TaskManager():
      cls.a2.Assemble()
    
    cls.f2 = LinearForm(DirichletSpace)
    with TaskManager():
      cls.f2.Assemble()
  
  
#------------------------------------------------------------------------------#


################################################################################
