

################################################################################


class DetailsStrayField:
  
  
#------------------------------------------------------------------------------#
  

  exists = False
  
  a1 = None
  c1 = None
  solverComp1 = None

  a2 = None
  c2 = None
  f2 = None
  
  
#------------------------------------------------------------------------------#


  def __init__(self, mesh, NeumannSpace, DirichletSpace, u2, solvetol):
    
    if not(type(self).exists):
      type(self)._femStrayStaticInitialize(mesh, NeumannSpace, DirichletSpace \
        , u2, solvetol)
      type(self).exists = True
  
  
  
#------------------------------------------------------------------------------#


  @classmethod
  def _femStrayStaticInitialize(cls, mesh, NeumannSpace, DirichletSpace, u2, solvetol):
    from ngsolve import LinearForm, CGSolver, TaskManager, Preconditioner \
      , Laplace, BilinearForm

    cls.a1 = BilinearForm(NeumannSpace, symmetric=False)
    cls.a1 += Laplace(1.0)
    
    cls.c1 = Preconditioner(cls.a1, "local")
    with TaskManager():
      cls.a1.Assemble()
      cls.solverComp1 = CGSolver(mat=cls.a1.mat, pre=cls.c1.mat \
        , precision=solvetol, maxsteps=4000)
    
    cls.a2 = BilinearForm(DirichletSpace, symmetric=False)
    cls.a2 += Laplace(1.0)

    cls.c2 = Preconditioner(cls.a2, "bddc")

    with TaskManager():
      cls.a2.Assemble()
    
    cls.f2 = LinearForm(DirichletSpace)
    with TaskManager():
      cls.f2.Assemble()


#------------------------------------------------------------------------------#


################################################################################
