# TOECDO
#
#################################################################################
## suppose innerMesh is a true interior of  outerMesh,
## in the sense that it is subset and that the bounderies are disjoint
##        _______________________________
##       |                               |
##       |               1               |
##       |        _______________        |
##       |       |               |       |
##       |       |               |       |
##       |       |       2       |       |
##       |       |               |       |
##       |       |_______________|       |
##       |                               |
##       |_______________________________|
##
#################################################################################
#
#
#def ExtractInnerMesh(combinedMesh, nr_outside=1, nr_inside=2, nr_void=0):
#    from netgen.meshing import Mesh, FaceDescriptor, Element3D, Element2D
#  
#  mesh = Mesh()
#  
#  nr_outer_dom = nr_outside
#  nr_outer_bc = nr_outside
#  nr_outer_surf = nr_outside
#  
#  nr_inner_dom = nr_inside
#  nr_inner_bc = nr_inside
#  nr_inner_surf = nr_inside
#  
#  restrictionMap = []
#  extensionMap = {}
#  
#  for K in combinedMesh.Elements3D():
#    if ( K.index == nr_inner_dom ):
#      for v in K.vertices:
#        if( v not in extensionMap ):
#          extensionMap[v] = mesh.Add( combinedMesh[v] )
#          restrictionMap.append( v.nr-1 )
#      
#      mesh.Add( Element3D(index=nr_inner_dom \
#        , vertices=[extensionMap[v] for v in K.vertices] ) )
#  
#  
#  ## boundary conditions
#  fd_inner_boundary = mesh.Add( FaceDescriptor(surfnr=nr_inner_surf \
#    , domin=nr_inner_dom, domout=nr_void, bc=nr_inner_bc) )
#  
#  for E in combinedMesh.Elements2D():
#    if ( E.index == nr_inner_bc ):
#      mesh.Add( Element2D(index=fd_inner_boundary \
#        , vertices=[extensionMap[v] for v in E.vertices] ) )
#  
#  return mesh, restrictionMap
#
#
#################################################################################
#
#
#def CombineMeshes(innerMesh, outerMesh, nr_outside=1, nr_inside=2, nr_void=0):
#    from netgen.meshing import Mesh, FaceDescriptor, Element2D
#  # adapted from 
#  # https://gitlab.asc.tuwien.ac.at/jschoeberl/ngsolve-docu/wikis/ngpy-meshes 
#  # on 2017/03/13
#  
#  mesh = Mesh()
#  
#  nr_outer_dom = nr_outside
#  nr_outer_bc = nr_outside
#  nr_outer_surf = nr_outside
#  
#  nr_inner_dom = nr_inside
#  nr_inner_bc = nr_inside
#  nr_inner_surf = nr_inside
#  fd_outside = mesh.Add( FaceDescriptor(surfnr=nr_outer_surf \
#    , domin=nr_outer_dom,  bc=nr_outer_bc) )
#  fd_inside = mesh.Add( FaceDescriptor(surfnr=nr_inner_surf \
#    , domin=nr_inner_dom, domout=nr_outer_dom, bc=nr_inner_bc) )
#  
#  
#  pmap1 = { }
#  for e in outerMesh.Elements2D():
#    for v in e.vertices:
#      if (v not in pmap1):
#        pmap1[v] = mesh.Add( outerMesh[v] )
#  
#  
#  for e in outerMesh.Elements2D():
#    mesh.Add( Element2D(fd_outside, [pmap1[v] for v in e.vertices]) )
#  
#  
#  pmap2 = { }
#  for e in innerMesh.Elements2D():
#    for v in e.vertices:
#      if (v not in pmap2):
#        pmap2[v] = mesh.Add( innerMesh[v] )
#  
#  
#  for e in innerMesh.Elements2D():
#    mesh.Add( Element2D(fd_inside, [pmap2[v] for v in e.vertices]) )
#  
#  mesh.GenerateVolumeMesh()
#  
#  return mesh
#
#
#################################################################################
