from . import _standardGeometry


################################################################################


class Cuboid(_standardGeometry._StandardGeometry):


#------------------------------------------------------------------------------#


  def __init__(self, input1, input2, input3=None):
    self._input1 = input1
    self._input2 = input2
    self._input3 = input3


#------------------------------------------------------------------------------#


  def _GetNgSolveGeometry(self):
    from netgen.csg import OrthoBrick, Pnt
  
    if isinstance(self._input1, tuple) and isinstance(self._input2, tuple):
      p1 = self._input1
      p2 = self._input2
    else:
      try:
        p1 = (-self._input1/2, -self._input2/2, -self._input3/2)
        p2 = (self._input1/2, self._input2/2, self._input3/2)
      except:
        print("From Cuboid -- inputs must be 2 (float, float, float) tuples \
          or 3 floats dimX, dimY, dimZ as inputs")
        raise TypeError
  
    P1 = Pnt(p1[0], p1[1], p1[2])
    P2 = Pnt(p2[0], p2[1], p2[2])
    return OrthoBrick(P1, P2).bc("bc_dirichlet")


#------------------------------------------------------------------------------#


################################################################################
