from . import _standardGeometry


################################################################################


class Disk(_standardGeometry._StandardGeometry):
  
  
#------------------------------------------------------------------------------#


  def __init__(self, diameter, thickness):
    self._diameter = diameter
    self._thickness = thickness


#------------------------------------------------------------------------------#

  
  def _GetNgSolveGeometry(self):
    from netgen.csg import Cylinder, Pnt, Plane, Vec
    ax1 = Pnt(0.0,0.0,-self._thickness/2.0)
    ax2 = Pnt(0.0,0.0,+self._thickness/2.0)
    coil = Cylinder(ax1, ax2, 0.5*self._diameter).bc("bc_dirichlet")
    lower = Plane(ax1, Vec(0.0, 0.0, -1.0) ).bc("bc_dirichlet")
    upper = Plane(ax2, Vec(0.0, 0.0, 1.0) ).bc("bc_dirichlet")
  
    cylinder = coil*upper*lower
    return cylinder


#------------------------------------------------------------------------------#


################################################################################
