

################################################################################


class Integrator:


#------------------------------------------------------------------------------#


  def __init__(self, scheme, geometry, parameters=None, output=None, numthreads = 1):

    self._integrator = scheme(geometry, parameters, output, numthreads)


#------------------------------------------------------------------------------#


  def Integrate(self, duration=None, relax=False):
    self._integrator.Integrate(duration=duration, relax=relax)


#------------------------------------------------------------------------------#


  def SaveMagnetization(self, filename=None):
    self._integrator.SaveMagnetization(filename)


#------------------------------------------------------------------------------#


  def SaveMesh(self, filename=None):
    self._integrator.SaveMesh(filename)


#------------------------------------------------------------------------------#


  def SetResultsFolder(self, foldername):
    self._integrator.SetResultsFolder(foldername)


#------------------------------------------------------------------------------#


  def SetParameter_A(self, value):
    self._integrator.SetParameter_A(value)


#------------------------------------------------------------------------------#


  def SetParameter_Ms(self, value):
    self._integrator.SetParameter_Ms(value)


#------------------------------------------------------------------------------#


  def SetParameter_K(self, value):
    self._integrator.SetParameter_K(value)


#------------------------------------------------------------------------------#


  def SetParameter_D(self, value):
    self._integrator.SetParameter_D(value)


#------------------------------------------------------------------------------#


  def SetParameter_alpha(self, value):
    self._integrator.SetParameter_alpha(value)


#------------------------------------------------------------------------------#


  def SetParameter_T_start(self, value):
    self._integrator.SetParameter_T_start(value)


#------------------------------------------------------------------------------#


  def SetParameter_T_end(self, value):
    self._integrator.SetParameter_T_end(value)


#------------------------------------------------------------------------------#


  def SetParameter_TimeStepSize(self, value):
    self._integrator.SetParameter_k(value)


#------------------------------------------------------------------------------#


  def SetParameter_H_ext(self, value):
    self._integrator.SetParameter_H_ext(value)


#------------------------------------------------------------------------------#


  def SetParameter_easy_axis(self, value):
    self._integrator.SetParameter_easy_axis(value)


#------------------------------------------------------------------------------#


  def SetParameter_P(self, value):
    self._integrator.SetParameter_P(value)


#------------------------------------------------------------------------------#


  def SetParameter_J(self, value):
    self._integrator.SetParameter_J(value)


#------------------------------------------------------------------------------#


  def SetParameter_xi(self, value):
    self._integrator.SetParameter_xi(value)


#------------------------------------------------------------------------------#


  def SetParameter_dmCoupling(self, value):
    self._integrator.SetParameter_dmCoupling(value)


#------------------------------------------------------------------------------#


  def SetParameter_maxwellCoupling(self, value):
    self._integrator.SetParameter_maxwellCoupling(value)


#------------------------------------------------------------------------------#


  def SetParameter_spintronicsCoupling(self, value):
    self._integrator.SetParameter_spintronicsCoupling(value)


#------------------------------------------------------------------------------#


  def SetParameter_Je(self, value):
    self._integrator.SetParameter_Je(value)


#------------------------------------------------------------------------------#


  def SetParameter_d(self, value):
    self._integrator.SetParameter_d(value)


#------------------------------------------------------------------------------#


  def SetParameter_p(self, value):
    self._integrator.SetParameter_p(value)


#------------------------------------------------------------------------------#


  def SetPreconditioner(self, value):
    self._integrator.SetPreconditioner(value)


#------------------------------------------------------------------------------#


  def SetGuess(self, value):
    self._integrator.SetGuess(value)


#------------------------------------------------------------------------------#


  def CountIterations(self, value=True):
    self._integrator.CountIterations(value)


#------------------------------------------------------------------------------#


  def SetTOL(self, value):
    self._integrator.SetTOL(value)


#------------------------------------------------------------------------------#


  def SetTheta(self, value):
    self._integrator.SetTheta(value)


#------------------------------------------------------------------------------#


  def RecordExternalFieldAt(self, value):
    self._integrator.RecordExternalFieldAt(value)


#------------------------------------------------------------------------------#


  def RecordMagnetization(self, record=True, maxwell=False, every=1.0e-09):
    self._integrator._RecordMagnetization(record, maxwell, every)


#------------------------------------------------------------------------------#


################################################################################
