### projection free TPS 1 ###
from . import tps1


################################################################################


class TPS1PF(tps1.TPS1):
  # description of TPS1PF (projection-free)


#------------------------------------------------------------------------------#

  
  def GetReady(self):
    from . import _tpsx

    self._solvetol = self.parameters.TOL
    self._theta = self.parameters.theta

    _tpsx.TPSX.GetReady(self)
  

#------------------------------------------------------------------------------#


  def _StepUpdate(self):
    self._Mag.m.vec.data += self._k * self._Mag.v.gf.vec


#------------------------------------------------------------------------------#


  def ProjectMagnetization(self):
    self._Mag.Project()


#------------------------------------------------------------------------------#


  @classmethod
  def _R_proj(cls, x, y, z):
    from scipy import sqrt
    from . import _tpsx
    epsilon = 1.0e-12
        
    tmp = sqrt(x*x + y*y + z*z)

    return _tpsx.TPSX._R_proj(x/tmp, y/tmp, z/tmp)
  
  
#------------------------------------------------------------------------------#


  @staticmethod
  def _IsMagProjected():
    return False


#------------------------------------------------------------------------------#


################################################################################
