from commix import *

h = 0.3

geo = Geometry(geometry=UnitCube(), meshSize=h, scaling=1.0)
par = Parameters(A=5.0, Ms=1.0, K=0.0, gamma0=1.0, mu0=1.0, alpha=0.5 \
  , timeStepSize=1.0e-03) 

par.m0 = (1.0, 0.0, 0.0)
par.H_ext = (-2.0, -0.5, 0.0)

academic = Integrator(scheme=TPS1, geometry=geo, parameters=par, numthreads=4)
academic.SetTheta(1.0)
academic.SetTOL(1.0e-10)

academic.SetResultsFolder("AcademicResult")

# tell that we want to count iterations
academic.CountIterations()

# choose preconditioner
#academic.SetPreconditioner(None) 
academic.SetPreconditioner("jacobi") 
#academic.SetPreconditioner("practical") 
#academic.SetPreconditioner("stationary") 

# choose initial guess
academic.SetGuess(None)
#academic.SetGuess("old")

# do
academic.Integrate(duration=5.0)
