from commix import *
from ngsolve import IfPos, x, y

geo = Geometry(geometry=Disk(80.0, 0.4), meshSize=1.0, scaling=1.0e-09)
par = Parameters(A=1.5e-11, Ms=5.8e+05, K=8.0e+05, alpha=0.3 \
  , spintronicsCoupling="slonczewski", D=5.0e-03, Je=2.0e+12, dmCoupling="interfacial", P=0.4 \
  , d=0.4e-09, timeStepSize=0.5e-12)
par.easy_axis = (0, 0, 1)
inside = IfPos(x*x + y*y - 20.0**2, 0.0, -1.0)
par.p = (0.0, 0.0, inside)

par.m0 = (0, 0, 1)

nuc = Integrator(scheme=TPS2AB, geometry=geo, parameters=par, numthreads=4)
nuc.SetResultsFolder("NucleationResult")

nuc.Integrate(duration=2.0e-09)
