from commix import *

geo = Geometry(geometry="data/sp4mesh.vol", scaling=1.0e-09)
par = Parameters(A=1.3e-11, Ms=8.0e+05, K=0.0, gamma0=2.211e+05, alpha=0.02 \
  , timeStepSize=0.5e-12)

par.m0 = "data/sp4sState.vtk"
par.H_ext = (-24.6e-03/par.mu0, 4.3e-03/par.mu0, 0.0)

sp4 = Integrator(scheme=TPS2AB, geometry=geo, parameters=par, numthreads=4)
sp4.SetResultsFolder("SP4Result")

sp4.RecordMagnetization(record=True, maxwell=True, every=10.0e-12)

sp4.Integrate(duration=3.0e-09)
