from commix import *

geo = Geometry(geometry="data/sp5mesh.vol", scaling=1.0e-09)
par = Parameters(A=1.3e-11, Ms=8.0e+05, K=0.0, gamma0=2.211e+05, alpha=0.1 \
  , spintronicsCoupling="zhangLi", g=2.0, P=1.0e+12, Je=(1.0, 0.0, 0.0), xi=0.05 \
  , timeStepSize=0.2e-12) 

par.m0 = "data/sp5relaxed.vtk"

sp5 = Integrator(scheme=TPS2AB, geometry=geo, parameters=par, numthreads=4)
sp5.SetResultsFolder("SP5Result")

sp5.Integrate(duration=8.0e-09)
